.\"     $NetBSD: sa_yield.2,v 1.3 2004/03/14 20:57:49 wiz Exp $
.\"
.\" Copyright (c)2004 YAMAMOTO Takashi,
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" ------------------------------------------------------------
.Dd May 9, 2004
.Dt SA_YIELD 2
.Os
.Sh NAME
.Nm sa_yield
.Nd idle a virtual processor
.\" ------------------------------------------------------------
.Sh LIBRARY
.Lb libc
.\" ------------------------------------------------------------
.Sh SYNOPSIS
.In sa.h
.Ft int
.Fn sa_yield
.\" ------------------------------------------------------------
.Sh DESCRIPTION
.Fn sa_yield
is used to idle a virtual processor on which the calling thread is running.
It's typically used when the process's userland scheduler has no userland
thread to run.
.Pp
Scheduler activation should be enabled by
.Fn sa_enable
beforehand.
.\" ------------------------------------------------------------
.Sh RETURN VALUES
On success,
.Fn sa_yield
will not return to userland in the normal way.
It returns into an upcall hander with an upcall.
Otherwise, a value of \-1 is returned and
.Va errno
is set to indicate the error.
.\" ------------------------------------------------------------
.Sh SEE ALSO
.Xr sa_enable 2 ,
.Xr pthread 3
